unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;

implementation

uses
  U_DataLink, U_iniParam, U_TradeDeliveryRequest, U_TradeClothDROutEdit,
  U_TradeClothInEdit, U_TradeClothInList, U_TradeClothOutEdit,
  U_TradeClothOutList, U_TradeClothStkList, U_TradeRRList, U_StockScanInEdit;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;
  SetLength(fDllFileName, 255);
  GetModuleFileName(HInstance, PChar(fDllFileName), Length(fDllFileName));
  fDllFileName := ExtractFileName(PChar(fDllFileName));
  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
    dtbase := 'yishuojydata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';

    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
    Parameters1 := '管理';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;
  if IsINIFile() then
    ReadINIFile()
  else
    WriteINIFile;
  GetsysParam('', '');
   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  bFound := False;
  if FormID <> 10000 then
  begin
    for i := 0 to Application.MainForm.MDIChildCount - 1 do
    begin
      if Application.MainForm.MDIChildren[i].Caption = Title then
      begin
        mnewHandle := Application.MainForm.MDIChildren[i].Handle;
        Application.MainForm.MDIChildren[i].BringToFront;
        bFound := True;
        Result := mnewHandle;
        exit;
      end;
    end;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    111:  //成品扫描入库
      begin
        with TfrmTradeClothInEdit.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    112:  //库存库位扫描
      begin
        with TfrmStockScanInEdit.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    121:  //成品入库
      begin
        with TfrmTradeClothInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    211:  //发货申请
      begin
        with TfrmTradeDeliveryRequest.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    221:  //申请扫描出库
      begin
        with TfrmTradeClothDROutEdit.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    311:  //成品扫描出库
      begin
        with TfrmTradeClothOutEdit.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    321:  //成品出库列表
      begin
        with TfrmTradeClothOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    411:  //成品库存列表
      begin
        with TfrmTradeClothStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    10000:
      begin
        for i := 0 to application.MainForm.MDIChildCount - 1 do
        begin
          if application.MainForm.MDIChildren[i].Caption = Title then
          begin
            application.MainForm.MDIChildren[i].Close;
          end;
        end;
      end;
  end;

  Result := mnewHandle;
end;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;
begin
  result := true;
  //////////////////////////////
//  shortDateFormat := 'yyyy-MM-dd';
  //服务器日期
  with DataLink_TradeClothStk.AdoDataLink do
  begin
    close;
    sql.Clear;
    sql.Add('select getDate()as dt');
    open;
    DServerDate := fieldByName('dt').AsDatetime;
  end;
  result := true;
end;

//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_TradeClothStk) then
    DataLink_TradeClothStk := TDataLink_TradeClothStk.Create(Application);
  try
    with DataLink_TradeClothStk.ADOLink do
    begin
      if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_TradeClothStk.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

